/**
 * \file
 *
 * \brief AVR,UC3,ARM\pIOPORT޽ͯ ̧
 *
 * 쌠 (c) 2012 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#ifndef IOPORT_H
#define IOPORT_H

#ifdef __cplusplus
extern "C" {
#endif

#include <parts.h>
#include <compiler.h>

/**
 * \defgroup ioport_service_group IOPORT API
 *
 * \ref ioport_quickstartB
 *
 * XMEGA,UC3,ARM޲ɓnĕWKGPIǑ݂`ԐݒƐ
 * 邽߂̋IOPORT޽łB
 *
 * ߰ ݐ亰ނ͊eՂɑ΂čœKA萔lgp鎞ɊȌƍ
 * sԂ̗𐶐ׂłB
 *
 * \section dependencies ˑ
 * ײނ͈ȉ̒PʕɈˑ܂:
 * - ۯxƋ@\̂߂\ref sysclk_group
 * @{
 */

/**
 * \def IOPORT_CREATE_PIN(port, pin)
 * \brief IOPORTݔԍ
 *
 * IOPORT֐ŎgpIOPORTݔԍ𐶐
 *
 * \param	port	IOPORT߰(Ⴆ΁AI񂾍\ɈˑPORTAAPAPIOA)
 * \param	pin		I/O݂IOPORT 0wW
 */

/** \brief IOPORTݕ */
enum ioport_direction {
	IOPORT_DIR_INPUT,		/*!< IOPORT͕ */
	IOPORT_DIR_OUTPUT,		/*!< IOPORTo͕ */
};

/** \brief IOPORT */
enum ioport_value {
	IOPORT_PIN_LEVEL_LOW,	/*!< IOPORTݒlLow */
	IOPORT_PIN_LEVEL_HIGH,	/*!< IOPORTݒlHigh */
};

/** \brief IOPORT[m */
enum ioport_sense {
	IOPORT_SENSE_BOTHEDGES,	/*!< IOPORT㏸Ɖ~̗m */
	IOPORT_SENSE_RISING,	/*!< IOPORT㏸[m */
	IOPORT_SENSE_FALLING,	/*!< IOPORT~[m */
};

#if XMEGA
# include "xmega/ioport.h"
# if defined(IOPORT_XMEGA_COMPAT)
#  include "xmega/ioport_compat.h"
# endif
#elif UC3
# include "uc3/ioport.h"
#elif SAM
# include "sam/ioport.h"
#endif

/**
 * \brief IOPORT޽Agp
 *
 * ̊֐IOPORT޽ő̂ǂ̊֐gp̂ɂ旧ČĂ΂Ȃ΂
 * ܂B
 */
static inline void ioport_init(void)
{
	arch_ioport_init();
}

/**
 * \brief \ref IOPORT_CREATE_PIN()ō쐬ꂽ݂ɊÂIOPORT݂
 *
 * \param	pin		IOPORT
 */
static inline void ioport_enable_pin(ioport_pin_t pin)
{
	arch_ioport_enable_pin(pin);
}

/**
 * \brief PIOPORT߰Ăŕ݂
 *
 * \param	port	IOPORT߰
 * \param	mask	߰ē݂̎Օ
 */
static inline void ioport_enable_port(ioport_port_t port,
		ioport_port_mask_t mask)
{
	arch_ioport_enable_port(port, mask);
}

/**
 * \brief IOPORT_CREATE_PIN()ō쐬ꂽ݂ɊÂIOPORT݂֎~
 *
 * \param	pin		֎~IOPORT
 */
static inline void ioport_disable_pin(ioport_pin_t pin)
{
	arch_ioport_disable_pin(pin);
}

/**
 * \brief PIOPORT߰Ăŕ݂֎~
 *
 * \param	port	֎~IOPORT߰
 * \param	mask	֎~߰ē݂̎Օ
 */
static inline void ioport_disable_port(ioport_port_t port,
		ioport_port_mask_t mask)
{
	arch_ioport_disable_port(port, mask);
}

/**
 * \brief PIOPORT߰Ăŕ݂ٱ߁A޳݂Ȃǂ̌`Ԑݒɐݒ
 *
 * \param	port	`Ԑݒ肷IOPORT߰
 * \param	mask	`Ԑݒ肷݂ݎՕ
 * \param	mode	w肵݂ɑ΂Č`Ԑݒ肷铮Օ(\ref ioport_modes)
 */
static inline void ioport_set_port_mode(ioport_port_t port,
		ioport_port_mask_t mask, ioport_mode_t mode)
{
	arch_ioport_set_port_mode(port, mask, mode);
}

/**
 * \brief 1̒PIOPORT݂ɑ΂ݓݒ
 *
 * \param	pin		`Ԑݒ肷IOPORT
 * \param	mode	w肵݂ɑ΂Č`Ԑݒ肷铮Օ(\ref ioport_modes)
 */
static inline void ioport_set_pin_mode(ioport_pin_t pin, ioport_mode_t mode)
{
	arch_ioport_set_pin_mode(pin, mode);
}

/**
 * \brief w肵IOPORT߰ē̕ݓؾ
 *
 * \param	pin		`Ԑݒ肷IOPORT
 * \param	mode	`Ԑݒ肪ؾĂ݂̎Օ
 */
static inline void ioport_reset_port_mode(ioport_port_t port,
		ioport_port_mask_t mask)
{
	arch_ioport_set_port_mode(port, mask, 0);
}

/**
 * \brief PIOPORT݂ɑ΂铮`Ԑݒؾ
 *
 * \param	pin		`Ԑݒ肷IOPORT
 */
static inline void ioport_reset_pin_mode(ioport_pin_t pin)
{
	arch_ioport_set_pin_mode(pin, 0);
}

/**
 * \brief PIOPORT݌Qɑ΂I/Oݒ
 *
 * \param	port	`Ԑݒ肷IOPORT߰
 * \param	mask	`Ԑݒ肷ݎՕ
 * \param	dir		w肵݂ɐݒ肷(\ref ioport_direction)
 */
static inline void ioport_set_port_dir(ioport_port_t port,
		ioport_port_mask_t mask, enum ioport_direction dir)
{
	arch_ioport_set_port_dir(port, mask, dir);
}

/**
 * \brief PIOPORT݂ɕݒ
 *
 * \param	pin		`Ԑݒ肷IOPORT
 * \param	dir		w肵݂ɐݒ肷(\ref ioport_direction)
 */
static inline void ioport_set_pin_dir(ioport_pin_t pin,
		enum ioport_direction dir)
{
	arch_ioport_set_pin_dir(pin, dir);
}

/**
 * \brief IOPRT݂w肵_lɐݒ
 *
 * \param	pin		`Ԑݒ肷IOPORT
 * \param	level	݂̘_l
 */
static inline void ioport_set_pin_level(ioport_pin_t pin, bool level)
{
	arch_ioport_set_pin_level(pin, level);
}

/**
 * \brief P߰ēIOPRT݌Qw肵_lɐݒ
 *
 * \param	port	IOPORT߰
 * \param	mask	ύX݂ݎՕ
 * \param	level	ύX݂
 */
static inline void ioport_set_port_level(ioport_port_t port,
		ioport_port_mask_t mask, ioport_port_mask_t level)
{
	arch_ioport_set_port_level(port, mask, level);
}

/**
 * \brief ͂ƂČ`Ԑݒ肳ꂽIOPORŤ݂ݒl擾
 *
 * \param	pin			ǂIOPORT
 * \return				w肵݂݂̘̌_l
 */
static inline bool ioport_get_pin_level(ioport_pin_t pin)
{
	return arch_ioport_get_pin_level(pin);
}

/**
 * \brief ͂ƂČ`Ԑݒ肳ꂽPP;ē̂IOPORŤ݂ݒl擾
 *
 * \param	port	ǂIOPORT߰
 * \param	mask	ǂ݂ݎՕ
 * \return			ՕƂĕԂAǂ߰Ăw肵݂̘_
 * a mask.
 */
static inline ioport_port_mask_t ioport_get_port_level(ioport_pin_t port,
		ioport_port_mask_t mask)
{
	return arch_ioport_get_port_level(port, mask);
}

/**
 * \brief ɏo͂ƂČ`Ԑݒ肳ꂽIOPORT݂̒l𔽓]
 *
 * \param	pin		]IOPORT
 */
static inline void ioport_toggle_pin_level(ioport_pin_t pin)
{
	arch_ioport_toggle_pin_level(pin);
}

/**
 * \brief P߰ĂɒuꂽIOPORT݂̒l𔽓]
 *
 * \param	port	ύXIOPORT߰
 * \param	mask	]݂ݎՕ
 */
static inline void ioport_toggle_port_level(ioport_port_t port,
		ioport_port_mask_t mask)
{
	arch_ioport_toggle_port_level(port, mask);
}

/**
 * \brief PIOPORT݂݊mݒ
 *
 * \param	pin			`Ԑݒ肷IOPORT
 * \param	pin_sense	݂ɑ΂Ċm[(\ref ioport_sense)
 */
static inline void ioport_set_pin_sense_mode(ioport_pin_t pin,
		enum ioport_sense pin_sense)
{
	arch_ioport_set_pin_sense_mode(pin, pin_sense);
}

/**
 * \brief P߰ĂŕIOPORT݂݊mݒ
 *
 * \param	port		`Ԑݒ肷IOPORT߰
 * \param	mask		݂̒[m`Ԑݒ肳邩ޯĎՕ
 * \param	pin_sense	݂ɑ΂Ċm[(\ref ioport_sense)
 */
static inline void ioport_set_port_sense_mode(ioport_port_t port,
		ioport_port_mask_t mask,
		enum ioport_sense pin_sense)
{
	arch_ioport_set_port_sense_mode(port, mask, pin_sense);
}

/**
 * \brief ID߰IDɕϊ
 *
 * \param 	pin		ϊIOPORTID
 * \retval			^ꂽIDɑ΂߰ID
 */
static inline ioport_port_t ioport_pin_to_port_id(ioport_pin_t pin)
{
	return arch_ioport_pin_to_port_id(pin);
}

/**
 * \brief ID߰Ăŗ^ꂽ݂ɑ΂ޯĎՕɕϊ
 *
 * \param	pin		ϊIOPORTID
 * \retval			߰ēŗ^ꂽIDɑΉݒޯĂޯĎՕ
 */
static inline ioport_port_mask_t ioport_pin_to_mask(ioport_pin_t pin)
{
	return arch_ioport_pin_to_mask(pin);
}

/** @} */

/**
 * \page ioport_quickstart IOPORT޽pJn̎
 *
 * ͎gpʂ̑Ił̻޽`Ԑݒ肵Ďg@̒iKIwł
 * \ref ioport_service_groupɑ΂鑦Jn̎łB
 *
 * gpʂ͂̺ޒfЂ܂݂܂BpiKł̺ޒfЂ͓Ǝ
 * ɕʂ邱ƂłAŎgpiḰAႦ΁A剞p֐ɕʂ邱
 * Ƃł܂B
 *
 * \section ioport_quickstart_basic {IȎgp
 * ̎gpʂł͖t͗p1I/O݂LEDpɌ`Ԑݒ肵܂B̌ɖt
 * ̏ԂǂłLEDɏo͂܂B
 *
 * \section ioport_quickstart_basic_setup iK
 *
 * \subsection ioport_quickstart_basic_setup_code ޗ
 * \code
 * #define MY_LED    IOPORT_CREATE_PIN(PORTA, 5)
 * #define MY_BUTTON IOPORT_CREATE_PIN(PORTA, 6)
 *
 * ioport_init();
 *
 * ioport_set_pin_dir(MY_LED, IOPORT_DIR_OUTPUT);
 * ioport_set_pin_dir(MY_BUTTON, IOPORT_DIR_INPUT);
 * ioport_set_pin_mode(MY_BUTTON, IOPORT_MODE_PULLUP);
 * \endcode
 *
 * \subsection ioport_quickstart_basic_setup_flow Ƃ̗
 * -# GPIOٖ^邱ƂLpŁA\ref IOPORT_CREATE_PINϸōs
 *    ł܂BLEDp1Ɩtp1`܂B
 *   - \code
 *     #define MY_LED    IOPORT_CREATE_PIN(PORTA, 5)
 *     #define MY_BUTTON IOPORT_CREATE_PIN(PORTA, 6)
 *     \endcode
 *   - \note \ref IOPORT_CREATE_PINϸۂ̗Lp߰Ė͊{\ԂňႢ܂B:
 *     - XMEGA: ߰Ē`APORTA,PORTB,`\ref IOPORT_CREATE_PINϸۂgpĂ
 *              B
 *     - UC3: ޲ ͯ ̧قݒ`Ił𒼐ڎĝł֗ŁA
 *            Ⴆ: VR32_PIN_PB06
 *     - SAM: ޲ ͯ ̧قݒ`Ił𒼐ڎĝł֗ŁA
 *            Ⴆ: PIO_PA5_IDX<br>
 *            \ref IOPORT_CREATE_PIN߰Ē`APIOA,PIOB,`Ŏg܂B
 * -# IOPORT޽܂B͈ʓIɕKvƂꍇI/OPʕ
 *    ܂B
 *   - \code ioport_init(); \endcode
 * -# LED GPIOo͂ƂĐݒ肵܂B:
 *   - \code ioport_set_pin_dir(MY_LED, IOPORT_DIR_OUTPUT); \endcode
 * -# tGPIO͂ƂĐݒ肵܂B:
 *   - \code ioport_set_pin_dir(MY_BUTTON, IOPORT_DIR_INPUT); \endcode
 * -# tGPIOɑ΂ٱ߂܂B:
 *   - \code ioport_set_pin_mode(MY_BUTTON, IOPORT_MODE_PULLUP); \endcode
 *
 * \section ioport_quickstart_basic_usage giK
 *
 * \subsection ioport_quickstart_basic_usage_code ޗ
 * \code
 * bool value;
 *
 * value = ioport_get_pin_level(MY_BUTTON);
 * ioport_set_pin_level(MY_LED, value);
 * \endcode
 *
 * \subsection ioport_quickstart_basic_usage_flow Ƃ̗
 * -# ԋLpްٕϐ`܂B:
 *   - \code bool value; \endcode
 * -# tقϐlɓǂݏo܂B:
 *   - \code value = ioport_get_pin_level(MY_BUTTON); \endcode
 * -# LEDtǂݏolɐݒ肵܂B:
 *   - \code ioport_set_pin_level(MY_LED, value); \endcode
 *
 * \section ioport_quickstart_advanced xȎgp
 * - \subpage ioport_quickstart_use_case_1 : ߰ 
 */

/**
 * \page ioport_quickstart_use_case_1 ߰ sxȎgp
 *
 * ̏ʂł1߰đŜǂݏoēǂ񂾒lʂ߰Ăɏ܂B
 *
 * \section ioport_quickstart_use_case_1_setup iK
 *
 * \subsection ioport_quickstart_use_case_1_setup_code ޗ
 * \code
 * #define IN_PORT  IOPORT_PORTA
 * #define OUT_PORT IOPORT_PORTB
 * #define MASK     0x00000060
 *
 * ioport_init();
 *
 * ioport_set_port_dir(IN_PORT, MASK, IOPORT_DIR_INPUT);
 * ioport_set_port_dir(OUT_PORT, MASK, IOPORT_DIR_OUTPUT);
 * \endcode
 *
 * \subsection ioport_quickstart_basic_setup_flow Ƃ̗
 * -# ߰ ٖ^邱ƂLpłB:
 *   - \code
 *     #define IN_PORT  IOPORT_PORTA
 *     #define OUT_PORT IOPORT_PORTB
 *     \endcode
 *   - \note ߰Ė͊{\ԂňႢ܂B:
 *     - XMEGA: ߰Ăɑ΂ė\ߒ`ꂽO܂B:
 *               IOPORT_PORTA,,IOPORT_PORTB,`
 *     - UC3: eI/O̎wWlgp : 0,1,`
 *     - SAM: ߰Ăɑ΂ė\ߒ`ꂽO܂B:
 *               IOPORT_PORTA,,IOPORT_PORTB,`
 * -# ɓޯĂɑ΂ĎՕ`邱ƂLpłB:
 *     - \code #define MASK     0x00000060 \endcode
 * -# IOPORT޽܂B͈ʓIɕKvƂꍇI/OPʕ
 *    ܂B
 *   - \code ioport_init(); \endcode
 * -# ߰Ă1͂ƂĐݒ肵܂B:
 *   - \code ioport_set_pin_dir(IN_PORT, MASK, IOPORT_DIR_INPUT); \endcode
 * -# ߰Ăo͂ƂĐݒ肵܂B:
 *   - \code ioport_set_pin_dir(OUT_PORT, MASK, IOPORT_DIR_OUTPUT); \endcode
 *
 * \section ioport_quickstart_basic_usage giK
 *
 * \subsection ioport_quickstart_basic_usage_code ޗ
 * \code
 * ioport_port_mask_t value;
 *
 * value = ioport_get_port_level(IN_PORT, MASK);
 * ioport_set_port_level(OUT_PORT, MASK, value);
 * \endcode
 *
 * \subsection ioport_quickstart_basic_usage_flow Ƃ̗
 * -# ߰ ްLpɕϐ`܂B:
 *   - \code ioport_port_mask_t value; \endcode
 * -# 1߰Ăǂݏo܂B:
 *   - \code value = ioport_get_port_level(IN_PORT, MASK); \endcode
 * -# ǂݏoް𑼂߰Ăɏo͂܂B:
 *   - \code ioport_set_port_level(OUT_PORT, MASK, value); \endcode
 */

#ifdef __cplusplus
}
#endif

#endif /* IOPORT_H */
