/**
 * \file *********************************************************************
 *
 * \brief USARTرٌ`Ԑݒ
 *
 * 쌠 (c) 2011 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#ifndef CONF_USART_SERIAL_H_INCLUDED
#define CONF_USART_SERIAL_H_INCLUDED


#ifdef __cplusplus
extern "C" {
	#endif

	// USARTرٌ`ԐݒCӑI

	#define USART_SERIAL_EXAMPLE			(&USARTD0)
	#define USART_SERIAL_EXAMPLE_BAUDRATE	(9600)
	#define USART_SERIAL_CHAR_LENGTH		(USART_CHSIZE_8BIT_gc)
	#define USART_SERIAL_PARITY				(USART_PMODE_DISABLED_gc)
	#define USART_SERIAL_STOP_BIT			(false)

	#ifdef __cplusplus
}
#endif

#define ENABLE_DEBUG		1
#define DISABLE_DEBUG		0

#define BIT_RESOLUTION_8	0
#define BIT_RESOLUTION_12	1


/**********************CONFIG*************************************/


#define  DEBUG							ENABLE_DEBUG

#define RESOLUTION_SELECT				BIT_RESOLUTION_12

#define  ADC_DATA_ACQUIRE_DELAY			6000

#if (RESOLUTION_SELECT == BIT_RESOLUTION_8)

	#define  MOUSE_OFFSET				4

#endif


#if (RESOLUTION_SELECT == BIT_RESOLUTION_12)

#define  MOUSE_OFFSET					8

#endif


#define FIRMWARE_VERSION				2.0.3


/*************************************************************************/

#define ADC_PORT_A						&ADCA

// ۸ޓ߰ 
#define JOYSTICK_INPUT_0				ADCCH_POS_PIN1		//PA1
#define JOYSTICK_INPUT_1				ADCCH_POS_PIN2		//PA2
#define JOYSTICK_INPUT_2				ADCCH_POS_PIN3		//PA3
#define JOYSTICK_INPUT_3				ADCCH_POS_PIN4		//PA4




#if (RESOLUTION_SELECT == BIT_RESOLUTION_8)
	#define  JOYSTICK_MIDDLE_VALUE		180
	#define  JOYSTICK_LOWER_VALUE		130
#endif

#if (RESOLUTION_SELECT == BIT_RESOLUTION_12)


#define  JOYSTICK_MIDDLE_VALUE			2900
#define  JOYSTICK_LOWER_VALUE			2450

#endif

#define DISABLE_BLOCK					0x00
#define ENABLE_BLOCK					0x01

#define JOYSTICK_MAX_MOVE				4000
#define JOYSTICK_MIN_MOVE				290

#define POSITION_CAL					0

extern int joystick_input_0,joystick_input_1,joystick_input_2,joystick_input_3;
static volatile int16_t adc_scan_results[4];

static double adc_dealy;

/*! \brief ϸۂٕϊ׸ނԂ܂B
 *
 *  \param	_adc_ch		ADC ڼ޽̈ւ̈ʒuwq
 *
 *  \return ٕϊ׸ނ̒l
 */
#define ADC_Ch_Conversion_Complete(_adc_ch)                                    \
	(((_adc_ch)->INTFLAGS & ADC_CH_CHIF_bm) != 0x00)
	
//#define delay_us( us )   ( __delay_cycles( ( F_CPU / 1000000UL ) * ( us ) ) )


#endif /* CONF_USART_SERIAL_H_INCLUDED */
