/**
 * \file
 *
 * \brief x~Ǘ
 *
 * 쌠 (c) 2010-2012 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#ifndef SLEEPMGR_H
#define SLEEPMGR_H

#include <compiler.h>
#include <sleep.h>
#include <parts.h>

#if (SAM3S || SAM3U || SAM3N || SAM3XA || SAM4S)
# include "sam/sleepmgr.h"
#elif XMEGA
# include "xmega/sleepmgr.h"
#elif (defined(__GNUC__) && defined(__AVR32__)) || (defined(__ICCAVR32__) || defined(__AAVR32__))
# include "uc3/sleepmgr.h"
#else
# error Unsupported device.
#endif

/**
 * \defgroup sleepmgr_group x~Ǘ
 *
 * x~Ǘͼ(Ⴆ΁AӋ@\ײށA޽Ap)ł̂
 * ޲[x~ł̋x~ɒuȂƂۏ؂邽߂̻-޽łB
 *
 * ͌ʋx~ɑ΂Œv̎gpɊÂA޲0̌Œv
 * ł󂢋x~ł̋x~ɒu܂Bײ/޽/p
 * \ref sleepmgr_lock_mode\ref sleepmgr_unlock_mode̎gpɂĂ̌v
 * ς邱Ƃł܂BŒɂ̂ɗp\ȋx~̈ꗗɂĂ
 * \ref sleepmgr_modǍʂ̏ɂĂ޲ްĂQƂĂ
 * B
 *
 * p\ref conf_sleepmgr.ḩقȂ΂Ȃ܂B
 *
 * ׂx~Ǘɑ΂āAق\ref CONFIG_SLEEPMGR_ENABLEAႦ
 * ΁A\ref conf_sleepmgr.hŒ`Ȃ΂Ȃ܂B̼ق`
 * ꍇA֐͋֐ŒuRAM͎gp܂B
 *
 * @{
 */

/**
 * \def CONFIG_SLEEPMGR_ENABLE
 * \brief x~Ǘ邽߂̌`Ԑݒ
 *
 * ̼ق͒`ꂸA̻޽̊֐͋֐Œu܂B͉p
 * ŋx~ǗKvƂȂꍇɺޗʂƎsԂ炷̂ɗLpłB
 *
 * ̼ق\ref conf_sleepmgr.hŒ`邩܂B
 */
#if defined(__DOXYGEN__) && !defined(CONFIG_SLEEPMGR_ENABLE)
#  define CONFIG_SLEEPMGR_ENABLE
#endif

/**
 * \enum sleepmgr_mode
 * \brief x~Œ
 *
 * ex~Œpʎq
 */

/**
 * \brief Œv
 *
 * 1ɐݒ肳Ō̕đSĂ̌Œv0ɐݒ肵܂B
 * \ref sleepmgr_enter_sleepōł[ŋe\ȋx~邽߂̎Z@
 * ȒP邽߂ɍs܂B
 */
static inline void sleepmgr_init(void)
{
#ifdef CONFIG_SLEEPMGR_ENABLE
	uint8_t i;

	for (i = 0; i < SLEEPMGR_NR_OF_MODES - 1; i++) {
		sleepmgr_locks[i] = 0;
	}
	sleepmgr_locks[SLEEPMGR_NR_OF_MODES - 1] = 1;
#endif /* CONFIG_SLEEPMGR_ENABLE */
}

/**
 * \brief x~ɑ΂Œv𑝉
 *
 * x~Ǘ޲[x~ł̋x~ɒuȂƂۏ؂邽߂
 * \a modeɑ΂Œv𑝉܂B
 *
 * \param	mode	Œ肷x~
 */
static inline void sleepmgr_lock_mode(enum sleepmgr_mode mode)
{
#ifdef CONFIG_SLEEPMGR_ENABLE
	irqflags_t flags;

	Assert(sleepmgr_locks[mode] < 0xff);

	// dv̈Ɉڍs
	flags = cpu_irq_save();

	++sleepmgr_locks[mode];

	// dv̈攲o
	cpu_irq_restore(flags);
#endif /* CONFIG_SLEEPMGR_ENABLE */
}

/**
 * \brief x~ɑ΂Œv
 *
 * \a modeɑ΂Œv܂BŒv0ɒBꍇAx~Ǘ
 * ޲[x~ł̋x~ɒu܂B
 *
 * \param	mode	Œ肩x~
 */
static inline void sleepmgr_unlock_mode(enum sleepmgr_mode mode)
{
#ifdef CONFIG_SLEEPMGR_ENABLE
	irqflags_t flags;

	Assert(sleepmgr_locks[mode]);

	// dv̈Ɉڍs
	flags = cpu_irq_save();

	--sleepmgr_locks[mode];

	// dv̈攲o
	cpu_irq_restore(flags);
#endif /* CONFIG_SLEEPMGR_ENABLE */
}

 /**
 * \brief e\Ȃ[x~擾
 *
 * łWx~삩n߂čŏ̔0Œv܂ŋx~Œv
 * ʂĒT܂Be\Ȃ[x~삪̌ɕԂ܂B
 */
static inline enum sleepmgr_mode sleepmgr_get_sleep_mode(void)
{
	enum sleepmgr_mode sleep_mode = SLEEPMGR_ACTIVE;

#ifdef CONFIG_SLEEPMGR_ENABLE
	uint8_t *lock_ptr = sleepmgr_locks;

	// ł󂢓Ŏn߂čŏ̔0Œv܂B
	while (!(*lock_ptr)) {
		lock_ptr++;
		sleep_mode++;
	}

	// ł[x~ősleepmgr_unlock_mode()Ăяȍꍇ߂炦
	// B
	Assert((uintptr_t)(lock_ptr - sleepmgr_locks) < SLEEPMGR_NR_OF_MODES);

#endif /* CONFIG_SLEEPMGR_ENABLE */

	return sleep_mode;
}

/**
 * \fn sleepmgr_enter_sleep
 * \brief ꂽŐ[ł̋x~֍sB
 *
 * łWx~삩n߂čŏ̔0Œv܂ŋx~Œv
 * ʂĒT܂B޲͂̌ɌŒɑΉx~ł̋x~ɒu܂B
 *
 * \note ̊֐͋x~֍sOɊ荞݂AAŋꂽ
 * ܂܂ɂ܂BACTIVE삪Œɂ邽߂ɋx~΂ꍇ
 * ɂKp܂B
 */

static inline void sleepmgr_enter_sleep(void)
{
#ifdef CONFIG_SLEEPMGR_ENABLE
	enum sleepmgr_mode sleep_mode;

	cpu_irq_disable();

	// e\ȍŐ[x~TB
	sleep_mode = sleepmgr_get_sleep_mode();
	// ŏ̓(ACTIVE)Œ肳Ă΁Aɖ߂܂B
	if (sleep_mode==SLEEPMGR_ACTIVE) {
		cpu_irq_enable();
		return;
	}
	// 荞݂Ƌɋe\ȍŐ[x~ֈڍs
	sleepmgr_sleep(sleep_mode);
#else
	cpu_irq_enable();
#endif /* CONFIG_SLEEPMGR_ENABLE */
}

//! @}

#endif /* SLEEPMGR_H */
