/**
 * \file
 *
 * \brief USBlԲ̪u(HID)K`
 *
 * 쌠 (c) 2009 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#ifndef _USB_PROTOCOL_HID_H_
#define _USB_PROTOCOL_HID_H_


/**
 * \ingroup usb_protocol_group
 * \defgroup usb_hid_protocol USBlԲ̪u(HID)K`
 * \brief USBlԲ̪u(HID)K`
 *
 * @{
 */

//! \name \ȸ׽l
//@{
#define  HID_CLASS					0x03
//@}

//! \name \ȕ׽l
//@{
#define  HID_SUB_CLASS_NOBOOT		0x00	//!< BOOTKxȂ̪ ׽
#define  HID_SUB_CLASS_BOOT			0x01	//!< BOOTKx̪ ׽
//@}

//! \name \ȋKl
//@{
#define  HID_PROTOCOL_GENERIC		0x00	//!< KSʕW
#define  HID_PROTOCOL_KEYBOARD		0x01	//!< KްޕW
#define  HID_PROTOCOL_MOUSE			0x02	//!< KϳW
//@}


//! \brief Hid USBv(bRequest)
enum usb_reqid_hid {
	USB_REQ_HID_GET_REPORT		= 0x01,
	USB_REQ_HID_GET_IDLE		= 0x02,
	USB_REQ_HID_GET_PROTOCOL	= 0x03,
	USB_REQ_HID_SET_REPORT		= 0x09,
	USB_REQ_HID_SET_IDLE		= 0x0A,
	USB_REQ_HID_SET_PROTOCOL	= 0x0B,
};

//! \brief HID USBLqq^
enum usb_descriptor_type_hid {
	USB_DT_HID					= 0x21,
	USB_DT_HID_REPORT			= 0x22,
	USB_DT_HID_PHYSICAL			= 0x23,
};

//! \brief 񍐋LqqpHID^
enum usb_hid_item_report_type {
	USB_HID_ITEM_REPORT_TYPE_MAIN	= 0,
	USB_HID_ITEM_REPORT_TYPE_GLOBAL	= 1,
	USB_HID_ITEM_REPORT_TYPE_LOCAL	= 2,
	USB_HID_ITEM_REPORT_TYPE_LONG	= 3,
};

//! \brief HID񍐌^
enum usb_hid_report_type {
	USB_HID_REPORT_TYPE_INPUT	= 1,
	USB_HID_REPORT_TYPE_OUTPUT	= 2,
	USB_HID_REPORT_TYPE_FEATURE	= 3,
};


//! \brief HIDK
enum usb_hid_protocol {
	USB_HID_PROCOTOL_BOOT		= 0,
	USB_HID_PROCOTOL_REPORT		= 1,
};

COMPILER_PACK_SET(1);

//! \brief HIDLqq
typedef struct {
	uint8_t bLength;			//!< ޲Ăł̂̋Lqq̑傫
	uint8_t bDescriptorType;	//!< HIDLqq^
	le16_t bcdHID;				//!< 2i10i̎dlJ
	uint8_t bCountryCode;		//!< ʰ޳Ώۍ
	uint8_t bNumDescriptors;	//!< HID׽Lqq
	uint8_t bRDescriptorType;	//!< 񍐋Lqq^
	le16_t wDescriptorLength;	//!< 񍐋Lqq̍v
} usb_hid_descriptor_t;

COMPILER_PACK_RESET();

   //! \name HID񍐌^
   //! SETUP_HID_GET_REPORT & SETUP_HID_SET_REPORTɂĎgp܂B
   //! @{
#define  REPORT_TYPE_INPUT					0x01
#define  REPORT_TYPE_OUTPUT					0x02
#define  REPORT_TYPE_FEATURE				0x03
   //! @}

   //! \name DESCRIPTOR_HID̈̓e
   //! @{
//! HID׽ʂ鐔
//! dlJ(łV1.11)
#define  USB_HID_BDC_V1_11					0x0111
//! ׽Lqqw肷鐔
//! : ɍŒ1AA񍐋Lqq
#define  USB_HID_NUM_DESC					0x01

      //! \name 
      //! @{
#define  USB_HID_NO_COUNTRY_CODE			 0   // x
#define  USB_HID_COUNTRY_ARABIC				 1   // ޱ
#define  USB_HID_COUNTRY_BELGIAN			 2   // ٷް
#define  USB_HID_COUNTRY_CANADIAN_BILINGUAL	 3   // -2
#define  USB_HID_COUNTRY_CANADIAN_FRENCH	 4   // -
#define  USB_HID_COUNTRY_CZECH_REPUBLIC		 5   // a
#define  USB_HID_COUNTRY_DANISH				 6   // ϰ
#define  USB_HID_COUNTRY_FINNISH			 7   // ̨ތ
#define  USB_HID_COUNTRY_FRENCH				 8   // 
#define  USB_HID_COUNTRY_GERMAN				 9   // ƌ
#define  USB_HID_COUNTRY_GREEK				10  // ؼ
#define  USB_HID_COUNTRY_HEBREW				11  // ײ
#define  USB_HID_COUNTRY_HUNGARY			12  // ݶذ
#define  USB_HID_COUNTRY_INTERNATIONAL_ISO	13  // (ISO)
#define  USB_HID_COUNTRY_ITALIAN			14  // Ɍ
#define  USB_HID_COUNTRY_JAPAN_KATAKANA		15  // {()
#define  USB_HID_COUNTRY_KOREAN				16  // N
#define  USB_HID_COUNTRY_LATIN_AMERICAN		17  // (߲݌)
#define  USB_HID_COUNTRY_NETHERLANDS_DUTCH	18  // ތ
#define  USB_HID_COUNTRY_NORWEGIAN			19  // ٳ
#define  USB_HID_COUNTRY_PERSIAN_FARSI		20  // ټ
#define  USB_HID_COUNTRY_POLAND				21  // ߰ތ
#define  USB_HID_COUNTRY_PORTUGUESE			22  // Ķٌ
#define  USB_HID_COUNTRY_RUSSIA				23  // I
#define  USB_HID_COUNTRY_SLOVAKIA			24  // ޷
#define  USB_HID_COUNTRY_SPANISH			25  // ߲݌
#define  USB_HID_COUNTRY_SWEDISH			26  // ݌
#define  USB_HID_COUNTRY_SWISS_FRENCH		27  // /
#define  USB_HID_COUNTRY_SWISS_GERMAN		28  // /ƌ
#define  USB_HID_COUNTRY_SWITZERLAND		29  // 
#define  USB_HID_COUNTRY_TAIWAN				30  // p
#define  USB_HID_COUNTRY_TURKISH_Q			31  // ٺ-Q
#define  USB_HID_COUNTRY_UK					32  // p
#define  USB_HID_COUNTRY_US					33  // Č
#define  USB_HID_COUNTRY_YUGOSLAVIA			34  // հ޽ޱ
#define  USB_HID_COUNTRY_TURKISH_F			35  // ٺ-F
      //! @}
   //! @}
//! @}


//! \name HIDl
//! @{
#define  HID_A					 4
#define  HID_B					 5
#define  HID_C					 6
#define  HID_D					 7
#define  HID_E					 8
#define  HID_F					 9
#define  HID_G					10
#define  HID_H					11
#define  HID_I					12
#define  HID_J					13
#define  HID_K					14
#define  HID_L					15
#define  HID_M					16
#define  HID_N					17
#define  HID_O					18
#define  HID_P					19
#define  HID_Q					20
#define  HID_R					21
#define  HID_S					22
#define  HID_T					23
#define  HID_U					24
#define  HID_V					25
#define  HID_W					26
#define  HID_X					27
#define  HID_Y					28
#define  HID_Z					29
#define  HID_1					30
#define  HID_2					31
#define  HID_3					32
#define  HID_4					33
#define  HID_5					34
#define  HID_6					35
#define  HID_7					36
#define  HID_8					37
#define  HID_9					38
#define  HID_0					39
#define  HID_ENTER				40
#define  HID_ESCAPE				41
#define  HID_BACKSPACE			42
#define  HID_TAB				43
#define  HID_SPACEBAR			44
#define  HID_UNDERSCORE			45
#define  HID_PLUS				46
#define  HID_OPEN_BRACKET		47	// {
#define  HID_CLOSE_BRACKET		48	// }
#define  HID_BACKSLASH			49
#define  HID_ASH				50	// # ~
#define  HID_COLON				51	// ; :
#define  HID_QUOTE				52	// ' "
#define  HID_TILDE				53
#define  HID_COMMA				54
#define  HID_DOT				55
#define  HID_SLASH				56
#define  HID_CAPS_LOCK			57
#define  HID_F1					58
#define  HID_F2					59
#define  HID_F3					60
#define  HID_F4					61
#define  HID_F5					62
#define  HID_F6					63
#define  HID_F7					64
#define  HID_F8					65
#define  HID_F9					66
#define  HID_F10				67
#define  HID_F11				68
#define  HID_F12				69
#define  HID_PRINTSCREEN		70
#define  HID_SCROLL_LOCK		71
#define  HID_PAUSE				72
#define  HID_INSERT				73
#define  HID_HOME				74
#define  HID_PAGEUP				75
#define  HID_DELETE				76
#define  HID_END				77
#define  HID_PAGEDOWN			78
#define  HID_RIGHT				79
#define  HID_LEFT				80
#define  HID_DOWN				81
#define  HID_UP					82
#define  HID_KEYPAD_NUM_LOCK	83
#define  HID_KEYPAD_DIVIDE		84
#define  HID_KEYPAD_AT			85
#define  HID_KEYPAD_MULTIPLY	85
#define  HID_KEYPAD_MINUS		86
#define  HID_KEYPAD_PLUS		87
#define  HID_KEYPAD_ENTER		88
#define  HID_KEYPAD_1			89
#define  HID_KEYPAD_2			90
#define  HID_KEYPAD_3			91
#define  HID_KEYPAD_4			92
#define  HID_KEYPAD_5			93
#define  HID_KEYPAD_6			94
#define  HID_KEYPAD_7			95
#define  HID_KEYPAD_8			96
#define  HID_KEYPAD_9			97
#define  HID_KEYPAD_0			98

   //! \name HIDCql
   //! @{
#define  HID_MODIFIER_NONE			0x00
#define  HID_MODIFIER_LEFT_CTRL		0x01
#define  HID_MODIFIER_LEFT_SHIFT	0x02
#define  HID_MODIFIER_LEFT_ALT		0x04
#define  HID_MODIFIER_LEFT_UI		0x08
#define  HID_MODIFIER_RIGHT_CTRL	0x10
#define  HID_MODIFIER_RIGHT_SHIFT	0x20
#define  HID_MODIFIER_RIGHT_ALT		0x40
#define  HID_MODIFIER_RIGHT_UI		0x80
   //! @}
//! @}

//! \name HIDl
//! @{
#define  HID_LED_NUM_LOCK			(1<<0)
#define  HID_LED_CAPS_LOCK			(1<<1)
#define  HID_LED_SCROLL_LOCK		(1<<2)
#define  HID_LED_COMPOSE			(1<<3)
#define  HID_LED_KANA				(1<<4)
//! @}

#endif // _USB_PROTOCOL_HID_H_
