/**
 * \file
 *
 * \brief USBu(UDC)̲̪
 *
 * 쌠 (c) 2009 - 2012 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#ifndef _UDC_H_
#define _UDC_H_

#include "conf_usb.h"
#include "usb_protocol.h"
#include "udc_desc.h"
#include "udd.h"

#ifdef __cplusplus
extern "C" {
#endif

/**
 * \ingroup usb_device_group
 * \defgroup udc_group USBu(UDC)
 *
 * UDCUSBu̍ʒۉ񋟂܂Bȓ(Jn/t/Nオ)
 * 𐧌䂷̂ɂ̊֐gp邱Ƃł܂B
 *
 * \section USB_DEVICE_CONF USBuƎ`Ԑݒ
 * ȉUSBu`Ԑݒ͉pconf_usb.ḩقɊ܂܂Ȃ΂Ȃ܂B
 *
 * USB_DEVICE_VENDOR_ID ()<br>
 * USBɂĒ񋟂鋟ID (ATMEL 0x03EB)
 *
 * USB_DEVICE_PRODUCT_ID ()<br>
 * iID (usb_atmel.hŎQƂ).
 *
 * USB_DEVICE_MAJOR_VERSION (޲)<br>
 * u̎Ŕԍ
 *
 * USB_DEVICE_MINOR_VERSION (޲)<br>
 * u̕Ŕԍ
 *
 * USB_DEVICE_MANUFACTURE_NAME ()<br>
 * Ǝ҂ASCII
 *
 * USB_DEVICE_PRODUCT_NAME ()<br>
 * iASCII
 *
 * USB_DEVICE_SERIAL_NAME ()<br>
 * ʔԂĐݒ肷邽߂ASCII
 *
 * USB_DEVICE_POWER (l)<br>
 * ő呕ud (PmA)
 *
 * USB_DEVICE_ATTR (޲)<br>
 * p\USB:
 *  - USB_CONFIG_ATTR_SELF_POWERED
 *  - USB_CONFIG_ATTR_REMOTE_WAKEUP
 *  : uNȂAuNĂі߂`ĂB
 *      \5-2. UDCpOAPI - Ăі߂B
 *
 * USB_DEVICE_LOW_SPEED (`̂)<br>
 * USBuᑬsɋ
 *
 * USB_DEVICE_HS_SUPPORT (`̂)<br>
 * USBusɔF
 *
 * USB_DEVICE_MAX_EP (޲)<br>
 * USBuɂĎgpő߲Đ`<br>
 * UDI`ԐݒŊɒ`܂B
 * :
 * - ߲ 0x00A߲ 0x010x82gpUSB_DEVICE_MAX_EP=2
 * - ߲ 0x00gpUSB_DEVICE_MAX_EP=0
 * - ߲ 0x010x81gpUSB_DEVICE_MAX_EP=1<br>
 *   (USBB̪ŕs\Ȍ`Ԑݒ)
 * @{
 */

/**
 * \brief VBUSۂF
 *
 * \return VBUSĎ\Ȃtrue
 *
 * \section udc_vbus_monitoring VBUSĎgp
 *
 * VBUSĎUSBȋdpɑ΂Ăgp܂B
 *
 *  -  ƎȂ \n
 *     // VBUSĎF \n
 *     if (!udc_include_vbus_monitoring()) { \n
 *       // VBUSĎ͂̐iŗps \n
 *       // ɂVBUS݂͑ƌ􂳂Ȃ΂Ȃ炸 \n
 *       // USBut \n
 *       udc_attach(); \n
 *     } \n
 *
 *  -  ƎVBUSĎǉ \n
 *     // VBUSĎF \n
 *     if (!udc_include_vbus_monitoring()) { \n
 *       // GPIO܂͂̑oRœƎVBUSĎ \n
 *     } \n
 *     Event_VBUS_present()	// VBUS荞݂܂GPIO荞݂܂͂̑ \n
 *     { \n
 *        // USBut \n
 *        udc_attach(); \n
 *     } \n
 *
 *  -  dr[d̏ꍇ \n
 *     Event VBUS present()	// VBUS荞݂܂GPIO荞݂܂́` \n
 *     { \n
 *        // dr[dF؁AUSBJn̂߂ɷҋ@ \n
 *     } \n
 *     Event Key press() \n
 *     { \n
 *        // dr[d~ \n
 *        // USBJn \n
 *        udc_attach(); \n
 *     }  \n
 */
static inline bool udc_include_vbus_monitoring(void)
{
	return udd_include_vbus_monitoring();
}

/*! \brief USBuKwJn
 */
void udc_start(void);

/*! \brief USBuKw~
 */
void udc_stop(void);

/**
 * \brief \Ȏɑu޽Ɏt
 *
 * \warning VBUS䂪ײނɊ܂܂ꍇAνĂ̎󂯓\VBUSق
 * oꂽɑut܂B
 */
static inline void udc_attach(void)
{
	udd_attach();
}


/**
 * \brief ޽瑕uO
 *
 * ײނUSBD-܂D+ٱ߂OȂ΂Ȃ܂B
 */
static inline void udc_detach(void)
{
	udd_detach();
}


/*! \brief USBײނ\e "ĊJ"ƌĂ΂ĊJM𑗂܂B
 * νĂɂĉuN@\鎞ɂF؂܂B
 */
static inline void udc_remotewakeup(void)
{
	udd_send_remotewakeup();
}


/**
 * \brief ݂̲̪Lqq̈ʒuwqԂ܂B
 *
 * \return	݂̲̪Lqq̈ʒuwq
 */
usb_iface_desc_t UDC_DESC_STORAGE *udc_get_interface_desc(void);

//@}

/**
 * \ingroup usb_group
 * \defgroup usb_device_group USBuKw
 *
 * ̒PʕUSBuKw܂݂܂BKw3̕ɕ܂B:
 * - USBu(UDC)USB9͏񋟂܂B
 * - USBu̪(UDI)USB׽񋟂܂B
 * - USBuuײ(UDD)͊eAtmel MCUpUSBײނ񋟂܂B

 * USBupAtmel MCUŎ邱Ƃł܂BAtmel͊e퉞pɑ΂
 * đ̉pLq񋟂܂B:
 * - AVR4900, uKwɂĂ̑SʓIȏ
 * - AVR4901, V׽쐬@
 * - AVR4902, u쐬@
 * - AVR49xx, ASFŒ񋟂SĂ̑u׽pLq܂B
 *
 * USBu׽(HID,MS,CDC,PHDC,`)pLq𗝉ɂ͊{IUSB̒mKv
 * Ƃ܂B̌ASFɂĒ񋟂1̸׽USBu쐬
 * ɂ́AUSB׽ɑΉ鉞pLq𒼐ڎQƂĂBV׽ƕ
 * ΂USBupLq͍xUSBgpҐpɂ܂B
 *
 * @{
 */

//! @}

#ifdef __cplusplus
}
#endif

/**
 * \ingroup udc_group
 * \defgroup udc_basic_use_case_setup_prereq USBu(UDC) - OKv
 * SĂUSBuɑ΂鋤ʎOKv
 *
 * ̒Pʕ͊SȊ荞݋쓮USBKwɊÂA\ref sleepmgr_group x~
 * (sleepmgr)\ref clk_group ۯ ޽x܂B
 *
 * ۼުĂ𐳂ɂ͈ȉ̎葱sȂ΂Ȃ܂B:
 * - ۯ`Ԑݒw:
 *   - XMEGA USBu48MHzۯ͂KvłB\n
 *     ڰъJnɂĎZRC 48MHzA܂͊OOSĈǂ炩
 *     gp邱Ƃł܂B
 *   - USBxUC3SAM޲48MHzۯ͂KvłB\n
 *     PLLƊOOSCgpȂ΂Ȃ܂B
 *   - USBxUC3SAM޲12MHzۯ͂KvłB\n
 *     OOSCgpȂ΂Ȃ܂B
 *   - USBCʰ޳UC3޲25MHzCPUgKvłB
 * - 荞݂
 * - ۯ ޽
 *
 * \ref sleepmgr_group x~Ǘ(sleepmgr)޽̎gp͔CӑIłAd͏
 * 炷߂ɐ܂B:
 * - x~Ǘ޽
 * - pIDLEԂ̎ɋx~
 *
 * \subpage udc_conf_clock.
 *
 * ނɒǉ:
 * \code
 *     sysclk_init();
 *     irq_initialize_vectors();
 *     cpu_irq_enable();
 *     board_init();
 *     sleepmgr_init();	// CӑI
 * \endcode
 * 屲(IDLE)JԂɒǉ:
 * \code
 *     sleepmgr_enter_sleep();	// CӑI
 * \endcode
 *
 */

/**
 * \ingroup udc_group
 * \defgroup udc_basic_use_case_setup_code USBu(UDC) - ޗ
 * SĂUSBupʺޗ
 *
 * conf_usb.h̓e:
 * \code
 * #define USB_DEVICE_VENDOR_ID 0x03EB
 * #define USB_DEVICE_PRODUCT_ID 0x0000
 * #define USB_DEVICE_MAJOR_VERSION 1
 * #define USB_DEVICE_MINOR_VERSION 0
 * #define USB_DEVICE_POWER 100
 * #define USB_DEVICE_ATTR USB_CONFIG_ATTR_BUS_POWERED
 * \endcode
 *
 * pÇقɒǉ:
 * \code
 * void usb_init(void)
 * {
 * udc_start();
 * udc_attach();
 * }
 * \endcode
 */

/**
 * \ingroup udc_group
 * \defgroup udc_basic_use_case_setup_flow USBu(UDC) - Ƃ̗
 * SĂUSBupʍƂ̗
 *
 * -# conf_usb.hp\ŎUSBu`Ԑݒłȉ̌`Ԑݒ܂ނƂm
 * ɂĂB:
 *   - \code	// USBɂĒ񋟂鋟ID(Atmel 0x03EB)
 * #define USB_DEVICE_VENDOR_ID 0x03EB	// ^
 * // iID(usb_atmel.hŎQƂAtmel PID)
 * #define USB_DEVICE_PRODUCT_ID 0x0000	// ^
 * // u̎Ŕԍ
 * #define USB_DEVICE_MAJOR_VERSION 1	// ޲Č^
 * // u̕Ŕԍ
 * #define USB_DEVICE_MINOR_VERSION 0	// ޲Č^
 * // ő呕ud(mA)
 * #define USB_DEVICE_POWER 100	// 9ޯČ^
 * // @\邽߂USB
 * #define USB_DEVICE_ATTR USB_CONFIG_ATTR_BUS_POWERED	// ׸ \endcode
 * -# Kw邽߂USBuKwJn֐Ăт܂B:
 *   - \code udc_start(); \endcode
 * -# USBuڑ:
 *   - \code udc_attach(); \endcode
 */

/**
 * \page udc_conf_clock conf_clock.h USBxł̗
 *
 * XMEGA conf_clock.h̓e:
 * \code
 * // RCɊÂ`Ԑݒ:
 * #define CONFIG_USBCLK_SOURCE			USBCLK_SRC_RCOSC
 * #define CONFIG_OSC_RC32_CAL			48000000UL
 * #define CONFIG_OSC_AUTOCAL			OSC_ID_RC32MHZ
 * #define CONFIG_OSC_AUTOCAL_REF_OSC	OSC_ID_USBSOF
 * \endcode
 *
 * xAT32UC3USBBpconf_clock.h̓e:
 * \code
 * // 12MHzOOSCɊÂ`Ԑݒ:
 * #define CONFIG_PLL1_SOURCE			PLL_SRC_OSC0
 * #define CONFIG_PLL1_MUL				8
 * #define CONFIG_PLL1_DIV				2
 * #define CONFIG_USBCLK_SOURCE			USBCLK_SRC_PLL1
 * #define CONFIG_USBCLK_DIV			1	// Fusb = Fsys/(2 ^ USB_div)
 * \endcode
 *
 * xłAT32UC3USBBpconf_clock.h̓e:
 * \code
 * // 12MHzOOSCɊÂ`Ԑݒ:
 * #define CONFIG_USBCLK_SOURCE			USBCLK_SRC_OSC0
 * #define CONFIG_USBCLK_DIV			1	// Fusb = Fsys/(2 ^ USB_div)
 * \endcode
 *
 * xAT32UC3USBCpconf_clock.h̓e:
 * \code
 * // 12MHzOOSCɊÂ`Ԑݒ:
 * #define CONFIG_PLL1_SOURCE			PLL_SRC_OSC0
 * #define CONFIG_PLL1_MUL				8
 * #define CONFIG_PLL1_DIV				2
 * #define CONFIG_USBCLK_SOURCE			USBCLK_SRC_PLL1
 * #define CONFIG_USBCLK_DIV			1	// Fusb = Fsys/(2 ^ USB_div)
 * // USBCœɂCPUۯ>25MHzKv
 * #define CONFIG_SYSCLK_SOURCE			SYSCLK_SRC_PLL1
 * \endcode
 *
 * xSAMpconf_clock.h̓e:
 * \code
 * // PLL1 (B)CӑI (Fpll = (Fclk * PLL_mul) / PLL_div)
 * #define CONFIG_PLL1_SOURCE			PLL_SRC_MAINCK_XTAL
 * #define CONFIG_PLL1_MUL				16
 * #define CONFIG_PLL1_DIV				2
 * // USBۯCӑI (Fusb = FpllX / USB_div)
 * #define CONFIG_USBCLK_SOURCE			USBCLK_SRC_PLL1
 * #define CONFIG_USBCLK_DIV			2
 * \endcode
 * 
 * USBxłSAM3Upconf_clock.h̓e:
 * \code
 * // UPLLŌŒ艻ꂽUSBۯ
 * \endcode
 * 
 * USBxłSAM3Xpconf_clock.h̓e:
 * \code
 * // UPLLŌŒ艻ꂽUSBۯ
 * #define CONFIG_USBCLK_SOURCE			USBCLK_SRC_UPLL
 * #define CONFIG_USBCLK_DIV			1
 * \endcode
 */

/**
 * \page udc_use_case_1 USBxύX
 *
 * ̎gpʂłUSBuقȂUSBxŎgp܂B
 *
 * \section udc_use_case_1_setup iK
 *
 * ̎gpʎɐ旧āAUDIPʕ"{IȎgp"ɓKpĂ
 * ƂmɂĂB
 *
 * \section udc_use_case_1_usage giK
 *
 * \subsection udc_use_case_1_usage_code ޗ
 * conf_usb.h̓e:
 * \code
 * #if	// ᑬ
 * #define USB_DEVICE_LOW_SPEED
 * // #define USB_DEVICE_HS_SUPPORT
 *
 * #elif	// S
 * // #define USB_DEVICE_LOW_SPEED
 * // #define USB_DEVICE_HS_SUPPORT
 *
 * #elif	// 
 * // #define USB_DEVICE_LOW_SPEED
 * #define USB_DEVICE_HS_SUPPORT
 *
 * #endif
 * \endcode
 *
 * \subsection udc_use_case_1_usage_flow Ƃ̗
 * -# conf_usb.hp\USBuᑬ(1.5Mbps)ɕKvƂȉҰ
 * ނƂmɂĂB:
 *   - \code #define USB_DEVICE_LOW_SPEED
 * //#define  USB_DEVICE_HS_SUPPORT \endcode
 * -# conf_usb.hUSBuS(12Mbps)ɕKvƂȉҰ܂ނƂm
 * ɂĂB:
 *   - \code //#define USB_DEVICE_LOW_SPEED
 * //#define  USB_DEVICE_HS_SUPPORT \endcode
 * -# conf_usb.hUSBuS(480Mbps)ɕKvƂȉҰ܂ނƂm
 * ɂĂB:
 *   - \code //#define USB_DEVICE_LOW_SPEED
 * #define  USB_DEVICE_HS_SUPPORT \endcode
 */

/**
 * \page udc_use_case_2 USB̎gp
 *
 * ̎gpʂłUSBuŒʏUSB񂪒ǉ܂B
 *
 * \section udc_use_case_2_setup iK
 * ̎gpʎɐ旧āAUDIPʕ"{IȎgp"ɓKpĂ
 * ƂmɂĂB
 *
 * \section udc_use_case_2_usage giK
 *
 * \subsection udc_use_case_2_usage_code ޗ
 * conf_usb.h̓e:
 * \code
 * #define  USB_DEVICE_MANUFACTURE_NAME		"Manufacture name"
 * #define  USB_DEVICE_PRODUCT_NAME			"Product name"
 * #define  USB_DEVICE_SERIAL_NAME			"12...EF"
 * \endcode
 *
 * \subsection udc_use_case_2_usage_flow Ƃ̗
 * -# conf_usb.hp\ŊeUSB̂ɕKvƂȉҰ
 * ܂ނƂmɂĂB:
 *   - \code	// ƎҗpÓIASCII
 * #define  USB_DEVICE_MANUFACTURE_NAME "Manufacture name" \endcode
 *   - \code	// ipÓIASCII
 * #define  USB_DEVICE_PRODUCT_NAME "Product name" \endcode
 *   - \code	// ʔԂĐݒ肷邽߂̐ÓIASCII
 * #define  USB_DEVICE_SERIAL_NAME "12...EF" \endcode
 */

/**
 * \page udc_use_case_3 USBuN@\̎gp
 *
 * ̎gpʂłUSBuN@\܂B
 *
 * \section udc_use_case_3_setup iK
 * ̎gpʎɐ旧āAUDIPʕ"{IȎgp"ɓKpĂ
 * ƂmɂĂB
 *
 * \section udc_use_case_3_usage giK
 *
 * \subsection udc_use_case_3_usage_code ޗ
 * conf_usb.h̓e:
 * \code
 * #define  USB_DEVICE_ATTR \
 *   (USB_CONFIG_ATTR_REMOTE_WAKEUP | USB_CONFIG_ATTR_..._POWERED)
 * #define UDC_REMOTEWAKEUP_ENABLE() my_callback_remotewakeup_enable()
 * extern void my_callback_remotewakeup_enable(void);
 * #define UDC_REMOTEWAKEUP_DISABLE() my_callback_remotewakeup_disable()
 * extern void my_callback_remotewakeup_disable(void);
 * \endcode
 *
 * pÇقɒǉĂB:
 * \code
 * void my_callback_remotewakeup_enable(void)
 * {
 *    // pNオ莖ۋ(Ⴆ΁AGPIO荞݋)
 * }
 * void my_callback_remotewakeup_disable(void)
 * {
 *    // pNオ莖ۋ֎~(Ⴆ΁AGPIO荞݋֎~)
 * }
 *
 * void my_interrupt_event(void)
 * {
 *    udc_remotewakeup();
 * }
 * \endcode
 *
 * \subsection udc_use_case_3_usage_flow Ƃ̗
 * -# conf_usb.hp\ŉuN@\̂ɕKvƂȉҰ
 * ܂ނƂmɂĂB:
 *   - \code	// uN@\F
 *     #define  USB_DEVICE_ATTR (USB_CONFIG_ATTR_REMOTE_WAKEUP | USB_CONFIG_ATTR_..._POWERED) \endcode
 *   - \code	// νĂuN@\鎞Ă΂Ăі߂`
 *     #define UDC_REMOTEWAKEUP_ENABLE() my_callback_remotewakeup_enable()
 *     extern void my_callback_remotewakeup_enable(void); \endcode
 *   - \code	// νĂuN@\֎~鎞Ă΂Ăі߂`
 *     #define UDC_REMOTEWAKEUP_DISABLE() my_callback_remotewakeup_disable()
 *     extern void my_callback_remotewakeup_disable(void); \endcode
 * -# Send a remote wakeup (USB upstream):
 *   - \code udc_remotewakeup(); \endcode
 */

/**
 * \page udc_use_case_4 ȋdp
 *
 * ̎gpʂłUSBuȋd܂BUSB̂߁AUSBقؒf
 * (ؒf=VBUS݂ȂAٱߋ֎~=\ref udd_detach())ꍇUSBuD+/-
 * ٱ߂֎~Ȃ΂ȂȂ̂ŁAȋdpVBUSۊǗKv
 * B̎gpʂAtmeliVBUSĎ܂ނƕKvŁAɂ葽̗ɂ
 * Ă\ref udc_include_vbus_monitoring@\B
 *
 * \section udc_use_case_4_setup iK
 * ̎gpʎɐ旧āAUDIPʕ"{IȎgp"ɓKpĂ
 * ƂmɂĂB
 *
 * \section udc_use_case_4_usage giK
 *
 * \subsection udc_use_case_4_usage_code ޗ
 * conf_usb.h̓e:
 * \code
 * #define  USB_DEVICE_ATTR (USB_CONFIG_ATTR_SELF_POWERED)
 * #define  UDC_VBUS_EVENT(b_vbus_high) user_callback_vbus_action(b_vbus_high)
 * extern void user_callback_vbus_action(bool b_vbus_high);
 * \endcode
 *
 * pÇقɒǉĂB:
 * \code
 * void user_callback_vbus_action(bool b_vbus_high)
 * {
 *   if (b_high) {
 *     // USBut
 *     udc_attach();
 *   } else {
 *     // VBUSs
 *     udc_detach();
 *   }
 * }
 * \endcode
 *
 * \subsection udc_use_case_4_usage_flow Ƃ̗
 * -# conf_usb.hp\USBuȋduɕKvƂȉҰ܂
 * ƂmɂĂB:
 *   - \code	// ȋd@\F
 * #define  USB_DEVICE_ATTR (USB_CONFIG_ATTR_SELF_POWERED) \endcode
 *   - \code	// VBUSٕωɌĂ΂Ăі߂`
 * #define  UDC_VBUS_EVENT(b_vbus_high) user_callback_vbus_action(b_vbus_high)
 * extern void user_callback_vbus_action(bool b_vbus_high); \endcode
 * -# USBUSBȗ݂}
 *   - \code udc_attach(); \endcode
 * -# USBUSBu݂̐M
 *   - \code udc_detach(); \endcode
 */

/**
 * \page udc_use_case_5 ޽dp
 *
 * ̎gpʂłUSBu޽d@\܂B̋@\͐d͏
 * KvłB
 *
 * \section udc_use_case_5_setup iK
 * ̎gpʎɐ旧āAUDIPʕ"{IȎgp"ɓKpĂ
 * ƂmɂĂB
 *
 * \section udc_use_case_5_usage giK
 *
 * \subsection udc_use_case_5_usage_code ޗ
 * conf_usb.h̓e:
 * \code
 * #define  USB_DEVICE_ATTR (USB_CONFIG_ATTR_BUS_POWERED)
 * #define  UDC_SUSPEND_EVENT()         user_callback_suspend_action()
 * extern void user_callback_suspend_action(void)
 * #define  UDC_RESUME_EVENT()          user_callback_resume_action()
 * extern void user_callback_resume_action(void)
 * \endcode
 *
 * pÇقɒǉĂB:
 * \code
 * void user_callback_suspend_action(void)
 * {
 *    // d͏炷߂ʰ޳֎~
 * }
 * void user_callback_resume_action(void)
 * {
 *    // ʰ޳ċ
 * }
 * \endcode
 *
 * \subsection udc_use_case_5_usage_flow Ƃ̗
 * -# conf_usb.hp\ňȉҰ܂ނƂmɂĂB:
 *   - \code	// ޽d@\F
 * #define  USB_DEVICE_ATTR (USB_CONFIG_ATTR_BUS_POWERED) \endcode
 *   - \code	// νĂUSBꎞ~鎞ɌĂ΂Ăі߂`
 * #define UDC_SUSPEND_EVENT() user_callback_suspend_action()
 * extern void user_callback_suspend_action(void); \endcode
 *   - \code	// νĂ܂͑uUSBĊJ鎞ɌĂ΂Ăі߂`
 * #define UDC_RESUME_EVENT() user_callback_resume_action()
 * extern void user_callback_resume_action(void); \endcode
 * -# ꎞ~œd͏ጸ(VBUSōő2.5mA):
 *   - \code void user_callback_suspend_action(void)
 * {
 * turn_off_components();
 * } \endcode
 */

/**
 * \page udc_use_case_6 USB Iʔ
 *
 * ̎gpʂłUSBʔԕ񂪓IłBÓIʔԕɂĂ
 * \ref udc_use_case_2QƂĂB
 *
 * \section udc_use_case_6_setup iK
 * ̎gpʎɐ旧āAUDIPʕ"{IȎgp"ɓKpĂ
 * ƂmɂĂB
 *
 * \section udc_use_case_6_usage giK
 *
 * \subsection udc_use_case_6_usage_code ޗ
 * conf_usb.h̓e:
 * \code
 * #define  USB_DEVICE_SERIAL_NAME
 * #define  USB_DEVICE_GET_SERIAL_NAME_POINTER serial_number
 * #define  USB_DEVICE_GET_SERIAL_NAME_LENGTH  12
 * extern uint8_t serial_number[];
 * \endcode
 *
 * pÇقɒǉĂB:
 * \code
 * uint8_t serial_number[USB_DEVICE_GET_SERIAL_NAME_LENGTH];
 *
 * void init_build_usb_serial_number(void)
 * {
 * serial_number[0] = 'A';
 * serial_number[1] = 'B';
 * ...
 * serial_number[USB_DEVICE_GET_SERIAL_NAME_LENGTH-1] = 'C';
 * } \endcode
 *
 * \subsection udc_use_case_6_usage_flow Ƃ̗
 * -# Ensure that conf_usb.hp\USBʔԕ𓮓Iɋ̂ɕKv
 * ȉ-܂ނƂmɂĂB:
 *   - \code #define  USB_DEVICE_SERIAL_NAME	// ̋`
 * #define  USB_DEVICE_GET_SERIAL_NAME_POINTER serial_number	// ʔԔzʒuwq^
 * #define  USB_DEVICE_GET_SERIAL_NAME_LENGTH  12	// ʔԔz̑傫^
 * extern uint8_t serial_number[];	// OʔԔz錾 \endcode
 * -# USBKwJnOɒʔԔzĂB
 *   - \code
 * uint8_t serial_number[USB_DEVICE_GET_SERIAL_NAME_LENGTH];
 *
 * void init_build_usb_serial_number(void)
 * {
 * serial_number[0] = 'A';
 * serial_number[1] = 'B';
 * ...
 * serial_number[USB_DEVICE_GET_SERIAL_NAME_LENGTH-1] = 'C';
 * } \endcode
 */


#endif // _UDC_H_
