/**
 * \file
 *
 * \brief USBu̪pAPI
 *
 * 쌠 (c) 2009 - 2012 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#ifndef _UDI_H_
#define _UDI_H_

#include "conf_usb.h"
#include "usb_protocol.h"

#ifdef __cplusplus
extern "C" {
#endif

/**
 * \ingroup usb_device_group
 * \defgroup udi_group USBu̪(UDI)
 * UDI͑SĂ̸׽ɑ΂鋤API񋟂AUSBu̪̎Ȑ̂
 * UDCɂĎgp܂B
 * @{
 */

/**
 * \brief UDI API
 *
 * ̍\̓̌Ăі߂USBu(UDC)ɂĂ̂݌Ă΂܂B
 *
 * udc_get_interface_desc()UDCɂđI΂ꂽ̪Lqqm邽߂UDI
 * Ďgp꓾܂B
 */
typedef struct {
	/**
	 * \brief ̪
	 *
	 * ̊֐νĂ`ԐݒݒvʂĂ̲̪`ԐݒI
	 * ԎνĂ̪ݒvʂĂ̲̪̑֐ݒIԎɌĂ
	 * ܂B
	 *
	 * \return	֐Ȉꍇ\c 1AłȂ\c 0
	 */
	bool(*enable) (void);

	/**
	 * \brief ̪֎~
	 *
	 * ̊֐̲̪͂݊Ŋȉ̎ɌĂ΂܂B
	 * - νĂ`Ԑݒݒvʂĉꂩ̌`ԐݒݒIԁA܂
	 * - νĂUSBؾĂ𔭍sA܂
	 * - uνĂO(AVBUS͂⑶݂Ȃ)
	 */
	void (*disable) (void);

	/**
	 * \brief ̪Ŏwꂽv
	 *
	 * ̊֐Ͳ̪݊νĂ҂ƂĂ̲̪SETUPv
	 * 鎞ɌĂ΂܂B
	 *
	 * SETUPv𕜍ĉɂudd_g_ctrlreqgpĂB
	 *
	 * \return	̲̪SETUPvxꍇ\c 1AłȂ\c 0
	 */
	bool(*setup) (void);

	/**
	 * \brief I񂾲̪݂̌̐ݒԂ܂B
	 *
	 * ̊֐UDCI񂾲̪̑֐ݒm鎞ɌĂ΂܂B
	 *
	 * \return	I񂾲̪̑֐ݒ
	 */
	uint8_t(*getsetting) (void);

	/**
	 * \brief SOFNꂽƂ}邽
	 */
	void(*sof_notify) (void);
} udi_api_t;

//@}

#ifdef __cplusplus
}
#endif
#endif // _UDI_H_
